#!/bin/sh
echo clean up source and build area
/bin/rm -rf gmp-4.1.4

echo make source tree and apply updates
tar xf gmp-4.1.4.tar
(cd gmp-4.1.4;patch gmp-impl.h ../gmp-impl.h.MPN_SIZEINBASE.diff)
(cd gmp-4.1.4;patch gmp-impl.h ../gmp-impl.h.MPF_SIGNIFICANT_DIGITS.diff)
(cd gmp-4.1.4/mpn/generic;patch rootrem.c ../../../mpn_rootrem.c.diff)

echo add patches to use intel compiler flavor of inline asm
(cd gmp-4.1.4;patch gmp-impl.h ../rag-gmp-impl.h.diff)
(cd gmp-4.1.4;patch longlong.h ../rag-longlong.h.diff)

echo configure gmp-4.1.4 with icc 9.0.024
(cd gmp-4.1.4;./configure \
	CC="/opt/intel/cc/9.0/bin/icc -i-static -fpic"
	CFLAGS="-g -O2 -std=c99 -ansi_alias -DRAG -ip" \
	CCAS="gcc -c" \
	--enable-alloca=malloc-reentrant \
	--enable-fft \
	--enable-shared \
	--disable-static \
	--prefix=/Devloper/gmp-4.1.4
	)

echo add patches to use intel compiler flavor of inline asm
(cd gmp-4.1.4;patch config.h ../rag-config.h.diff)
(cd gmp-4.1.4/mpn/generic;patch mul_basecase.c ../../../rag-mul_basecase.c.diff)

echo make gmp-4.1.4 with icc 9.0.024
(cd gmp-4.1.4;make)
(cd gmp-4.1.4;make install)

echo update libraries with asm routines
/opt/intel/cc/9.0/bin/ias rag_addmul_1.s
/opt/intel/cc/9.0/bin/ias rag_addmul_2.s
/opt/intel/cc/9.0/bin/ias rag_addmul_3.s
/opt/intel/cc/9.0/bin/ias rag_addmul_4.s
/opt/intel/cc/9.0/bin/ias rag_mul_1.s
/opt/intel/cc/9.0/bin/ias rag_mul_2.s
/opt/intel/cc/9.0/bin/ias rag_mul_3.s
/opt/intel/cc/9.0/bin/ias rag_mul_4.s
/opt/intel/cc/9.0/bin/ias rag_add_n.s
/opt/intel/cc/9.0/bin/ias rag_sub_n.s
/opt/intel/cc/9.0/bin/ias rag_popcount.s

echo run developer tests
# (cd gmp-4.1.4/tests;make check)

