//
///* mpn_mul_2 -- multiply the N long limb vector pointed to by UP by 
//   the first two long limbs pointed to by VP,
//   placing the N+1 limbs of the product in the limb vector
//   pointed to by RP.  Return the most significant limb of the product.
//
//Copyright 1992, 1993, 1994, 1996, 2000, 2002 Free Software Foundation, Inc.
//
//This file is part of the GNU MP Library.
//
//The GNU MP Library is free software; you can redistribute it and/or modify
//it under the terms of the GNU Lesser General Public License as published by
//the Free Software Foundation; either version 2.1 of the License, or (at your
//option) any later version.
//
//The GNU MP Library is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
//License for more details.
//
//You should have received a copy of the GNU Lesser General Public License
//along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
//the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//MA 02111-1307, USA. */
//
//#include "gmp.h"
//#include "gmp-impl.h"
//#include "longlong.h"
//
//#include "HP-Intel_inline_assembly.h"
//
//typedef unsigned long __predreg;
//
//#if !defined(mul_2)
//#define mul_2 __MPN(mul_2)
//#endif
//
//#if GMP_NAIL_BITS == 0
//
//mp_limb_t
//mul_2 (mp_ptr rp, mp_srcptr up, mp_size_t n, mp_srcptr vp)
//{
//
//  __predreg c_out_0 = 0, c_out_1 = 0;
//  __predreg c_not_0 = 1, c_not_1 = 1;
//
//  mp_limb_t lpl_0,       lpl_1;
//  mp_limb_t hpl_0,       hpl_1;
//  mp_limb_t rl_0,        rl_1;
//
//  __fpreg   __fvl_0,     __fvl_1;
//  __fpreg   __fpl_0,     __fpl_1;
//  __fpreg   __fph_0,     __fph_1;
//  __fpreg   __ful_i;
//
//  __fvl_0 = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&vp[0]) );
//  __fvl_1 = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&vp[1]) );
//
//  __fph_0 = _Asm_fmov ( _LDHINT_NONE, "f0" );
//  __fph_1 = _Asm_fmov ( _LDHINT_NONE, "f0" );
//
//  rl_0 = 0;
//
//#pragma swp
//  for (int i = 0; i < n; i++) /* 2 + 2*7 + 2 = 18 instructions (2 in 4 cycles) */
//    {
//
//      __ful_i = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&up[i]) );
//
//      rl_1 = 0;
//
//      __fpl_0 = _Asm_xma  ( _XM_LU, __fvl_0, __ful_i, __fph_0);
//      __fph_0 = _Asm_xma  ( _XM_HU, __fvl_0, __ful_i, __fph_0);
//      lpl_0   = _Asm_getf ( _FR_SIG, __fpl_0);
//
//      if (c_out_0) rl_0 = rl_0 + lpl_0 + 1;
//      if (c_not_0) rl_0 = rl_0 + lpl_0;
//
//      if (c_out_0) c_out_0 = (rl_0 <= lpl_0);
//      if (c_not_0) c_out_0 = (rl_0 <  lpl_0); c_not_0 = !c_out_0;
//
//      __fpl_1 = _Asm_xma  ( _XM_LU, __fvl_1, __ful_i, __fph_1);
//      __fph_1 = _Asm_xma  ( _XM_HU, __fvl_1, __ful_i, __fph_1);
//      lpl_1   = _Asm_getf ( _FR_SIG, __fpl_1);
//
//      if (c_out_1) rl_1 = rl_1 + lpl_1 + 1;
//      if (c_not_1) rl_1 = rl_1 + lpl_1;
//
//      if (c_out_1) c_out_1 = (rl_1 <= lpl_1);
//      if (c_not_1) c_out_1 = (rl_1 <  lpl_1); c_not_1 = !c_out_1;
//
//      rp[i] = rl_0;
//
//      rl_0 = rl_1;
//
//    }
//
//  hpl_0 = _Asm_getf ( _FR_SIG, __fph_0);
//  hpl_1 = _Asm_getf ( _FR_SIG, __fph_1);
//
//  if (c_out_0) rl_0 = rl_0 + hpl_0 + 1;
//  if (c_not_0) rl_0 = rl_0 + hpl_0;
//
//  if (c_out_0) c_out_0 = (rl_0 <= hpl_0);
//  if (c_not_0) c_out_0 = (rl_0 <  hpl_0);
//
//  rp[n + 0] = rl_0;
//
//  if (c_out_1) rl_1 = hpl_1 + 1;
//  if (c_not_1) rl_1 = hpl_1;
//
//  if (c_out_0) rl_1++;
//
//  return rl_1;
//
//}
//
//#endif
//
//#if GMP_NAIL_BITS >= 1
//you lose
//#endif
        .section .text
        .file "mul_2.s"
        .section .text, "xa", "progbits"
        .align 64
// -- Begin __gmpn_mul_2
        .proc __gmpn_mul_2#
        .global __gmpn_mul_2#

// Arguments //

Arg_RP=r32
Arg_UP=r33
Arg_N =r34
Arg_VP=r35

// ABI //

ret_val = r8 

savePR  = r27
savePFS = r28
saveLC  = r29

// Static GR //

// copies of args

reg_n = r14
pRPst = r15
pUP   = r16

// locals

hpl_0=r17
hpl_1=r18

// temps

pVP_1=r19

// Rotating GR //

lpl_0_3 = r32
lpl_0_4 = r33
lpl_0_5 = r34

lpl_1_3 = r35
lpl_1_4 = r36
lpl_1_5 = r37

// special rotation rl_1 -> rl_0

rl_1_0  = r38
rl_1_1  = r39 ; rl_0_0  = r39
rl_1_2  = r40 ; rl_0_1  = r40
rl_1_3  = r41 ; rl_0_2  = r41
rl_1_4  = r42 ; rl_0_3  = r42
rl_1_5  = r43 ; rl_0_4  = r43
                rl_0_5  = r44

// Static FR //

fvl_0 = f6
fvl_1 = f7

// Rotating FR //

ful_i_0=f32
ful_i_1=f33
ful_i_2=f34

fpl_0_2=f35
fpl_0_3=f36

fpl_1_2=f37
fpl_1_3=f38

fph_0_0=f39
fph_0_1=f40
fph_0_2=f41
fph_0_3=f42
fph_0_4=f43
fph_0_5=f44

fph_1_0=f45
fph_1_1=f46
fph_1_2=f47
fph_1_3=f48
fph_1_4=f49
fph_1_5=f50

// Rotating PR //

S0 = p16
S1 = p17
S2 = p18
S3 = p19
S4 = p20
S5 = p21

c_out_1_0 = p22
c_out_1_1 = p23
c_out_1_2 = p24
c_out_1_3 = p25
c_out_1_4 = p26
c_out_1_5 = p27

c_out_0_0 = p28
c_out_0_1 = p29
c_out_0_2 = p30
c_out_0_3 = p31
c_out_0_4 = p32
c_out_0_5 = p33

c_not_1_0 = p34
c_not_1_1 = p35
c_not_1_2 = p36
c_not_1_3 = p37
c_not_1_4 = p38
c_not_1_5 = p39

c_not_0_0 = p40
c_not_0_1 = p41
c_not_0_2 = p42
c_not_0_3 = p43
c_not_0_4 = p44
c_not_0_5 = p45

__gmpn_mul_2:
 {   .mmi
        alloc       savePFS=ar.pfs,4,12,0,16    // ABI 4 in 12 local 16 rotating
        mov         rl_0_0=r0                   // rl_0 = 0;
        mov         savePR=pr                   // ABI save PR
} {   .mmi
        add         pVP_1=8,Arg_VP              // pVP_1 = &vp[1];
        nop.m       0                           //
        add         reg_n=-1,Arg_N              // pre-decrement for ar.lc
;; }
{   .mfi
        ldf8        fvl_0=[Arg_VP]              // fvl_0 = vp[0];
        mov         fph_0_0=f0                  // fph_0 = 0;
        mov         saveLC=ar.lc                // ABI save LC
;; }
{   .mfi
        ldf8        fvl_1=[pVP_1]               // fvl_1 = vp[1];
        mov         fph_1_0=f0                  // fph_1 = 0;
        mov         pr.rot=0x10000              // set p16, clear higher
;; }
 {   .mmi
        add         pRPst=0,Arg_RP              // initialize to &RP[0]
        nop.m       0                           // 
	mov         ar.lc=reg_n                 // load loop count register
;; }
 {   .mmi
        nop.m       0                           //
        mov         pUP=Arg_UP                  // copy from args to static
        mov         ar.ec=6                     // want normal swp loop
 } {   .mmi
        nop.m       0                           // 
        cmp.ne      c_out_0_0,c_not_0_0=r0,r0   // c_out_0 and c_not_0
        cmp.ne      c_out_1_0,c_not_1_0=r0,r0   // c_out_1 and c_not_1
;; }
.rag_loop: 
	.pred.rel "mutex", c_out_0_5,c_not_0_5
{.mfi
(S3)     getf.sig   lpl_0_3=fpl_0_3             // lpl_0 = fpl_0
(S2)     xma.lu fpl_0_2=fvl_0,ful_i_2,fph_0_2   //
(c_out_0_5)add         rl_0_5=rl_0_5,lpl_0_5,1  // if(c_out_0)rl_0=rl_0+lpl_0+1;
} {.mfi
(S0)     ldf8        ful_i_0=[pUP],8            // ful_i_0 = up[i];
(S2)     xma.hu fph_0_1=fvl_0,ful_i_2,fph_0_2   // result needed next iteration
(c_not_0_5)add         rl_0_5=rl_0_5,lpl_0_5    // if(c_not_0)rl_0=rl_0+lpl_0;
;; }
	.pred.rel "mutex", c_out_1_5,c_not_1_5
{.mfi
(S3)     getf.sig   lpl_1_3=fpl_1_3             // lpl_1 = fpl_1
(S2)     xma.lu fpl_1_2=fvl_1,ful_i_2,fph_1_2   //
(c_out_1_5)add         rl_1_5=rl_1_5,lpl_1_5,1  // if(c_out_1)rl_1=rl_1+lpl_1+1;
} {.mfi
(S0)     mov         rl_1_0=r0                  // rl_1 = 0;
(S2)     xma.hu fph_1_1=fvl_1,ful_i_2,fph_1_2   // result needed next iteration
(c_not_1_5)add         rl_1_5=rl_1_5,lpl_1_5    // if(c_not_1)rl_1=rl_1+lpl_1;
;; }
	.pred.rel "mutex", c_out_0_5,c_not_0_5
	.pred.rel "mutex", c_out_1_5,c_not_1_5
{.mmi
(S5)     st8         [pRPst]=rl_0_5,8           // rp[i] = rl_0;
(c_out_0_5)cmp.leu c_out_0_4,c_not_0_4=rl_0_5,lpl_0_5  // (rl_0 <= lpl_0 )
(c_not_0_5)cmp.ltu c_out_0_4,c_not_0_4=rl_0_5,lpl_0_5  // (rl_0 <  lpl_0 )
} {.mmb
(c_out_1_5)cmp.leu c_out_1_4,c_not_1_4=rl_1_5,lpl_1_5  // (rl_1 <= lpl_1 )
(c_not_1_5)cmp.ltu c_out_1_4,c_not_1_4=rl_1_5,lpl_1_5  // (rl_1 <  lpl_1 )
         br.ctop.dptk .rag_loop                 //
;; }
///////////////////////////////////////////////////////////
{.mmi
         getf.sig   hpl_0=fph_0_5              // hpl_0 = fph_0
	 nop.m 0
	 nop.i 0
;; }
{.mmi
         getf.sig   hpl_1=fph_1_5              // hpl_1 = fph_1
	 nop.m 0
	 nop.i 0
;; }
	.pred.rel "mutex", c_out_0_5,c_not_0_5
{.mmi
(c_out_0_5)add         rl_0_5=rl_0_5,hpl_0,1  // if(c_out_0)rl_0=rl_0+hpl_0+1;
(c_not_0_5)add         rl_0_5=rl_0_5,hpl_0    // if(c_not_0)rl_0=rl_0+hpl_0;
	   nop.i 0
;; }
	.pred.rel "mutex", c_out_0_5,c_not_0_5
{.mmi
        st8         [pRPst]=rl_0_5,8          // rp[n + 0] = rl_0;
(c_out_0_5)cmp.leu c_out_0_0,p0=rl_0_5,hpl_0  // (rl_0 <= hpl_0 )
(c_not_0_5)cmp.ltu c_out_0_0,p0=rl_0_5,hpl_0  // (rl_0 <  hpl_0 )
;; }

	.pred.rel "mutex", c_out_1_5,c_not_1_5
{.mmi
(c_out_1_5)add         rl_1_5=r0,hpl_1,1      // if(c_out_1)rl_1=hpl_1+1;
(c_not_1_5)add         rl_1_5=r0,hpl_1        // if(c_not_1)rl_1=hpl_1;
	nop.i 0
;; }

{.mii
(c_out_0_0) add rl_1_5=1,rl_1_5               // if(c_out_0)rl_1++
	mov         ar.lc = saveLC
        nop.i 0
;; }

 { .mib
         mov        ret_val=rl_1_5            // return rl_1;
         mov        pr=savePR,0x1003e         // ABI
         br.ret.sptk.many b0                  // all done
;; }
// -- End __gmpn_mul_2
        .endp __gmpn_mul_2#
