//
///* mpn_mul_3 -- multiply the N long limb vector pointed to by UP by 
//   the first three long limbs pointed to by VP,
//   placed the N+2 least significant limbs of the product to the limb vector
//   pointed to by RP.  Return the most significant limb of the product,
//   adjusted for carry-out from the addition.
//
//Copyright 1992, 1993, 1994, 1996, 2000, 2002 Free Software Foundation, Inc.
//
//This file is part of the GNU MP Library.
//
//The GNU MP Library is free software; you can redistribute it and/or modify
//it under the terms of the GNU Lesser General Public License as published by
//the Free Software Foundation; either version 2.1 of the License, or (at your
//option) any later version.
//
//The GNU MP Library is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
//License for more details.
//
//You should have received a copy of the GNU Lesser General Public License
//along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
//the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
//MA 02111-1307, USA. */
//
//#include "gmp.h"
//#include "gmp-impl.h"
//#include "longlong.h"
//
//#include "HP-Intel_inline_assembly.h"
//
//typedef unsigned long __predreg;
//
//#if !defined(mul_3)
//#define mul_3 __MPN(mul_3)
//#endif
//
//#if GMP_NAIL_BITS == 0
//
//mp_limb_t
//mul_3 (mp_ptr rp, mp_srcptr up, mp_size_t n, mp_srcptr vp)
//{
//
//  __predreg c_out_0 = 0, c_out_1 = 0;
//  __predreg c_not_0 = 1, c_not_1 = 1;
//  __predreg c_out_2 = 0;
//  __predreg c_not_2 = 1;
//
//  mp_limb_t lpl_0, lpl_1, lpl_2;
//  mp_limb_t hpl_0, hpl_1, hpl_2;
//  mp_limb_t rl_0,  rl_1,  rl_2;
//
//  __fpreg   __fvl_0, __fvl_1, __fvl_2;
//  __fpreg   __fpl_0, __fpl_1, __fpl_2;
//  __fpreg   __fph_0, __fph_1, __fph_2;
//  __fpreg   __ful_i;
//
//  __fvl_0 = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&vp[0]) );
//  __fvl_1 = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&vp[1]) );
//  __fvl_2 = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&vp[2]) );
//
//
//  __fph_0 = _Asm_fmov ( _LDHINT_NONE, "f0" );
//  __fph_1 = _Asm_fmov ( _LDHINT_NONE, "f0" );
//  __fph_2 = _Asm_fmov ( _LDHINT_NONE, "f0" );
//
//  rl_0 = 0; 
//  rl_1 = 1;
//
//#pragma swp
//  for (int i = 0; i < n; i++) /* 2 + 2*7 + 2 = 18 instructions (2 in 4 cycles) */
//    {
//
//      __ful_i = _Asm_ldf8 ( _LDHINT_NONE, (void *)(&up[i]) );
//
//      rl_2 = 0;
//
//      __fpl_0 = _Asm_xma  ( _XM_LU, __fvl_0, __ful_i, __fph_0);
//      __fph_0 = _Asm_xma  ( _XM_HU, __fvl_0, __ful_i, __fph_0);
//      lpl_0   = _Asm_getf ( _FR_SIG, __fpl_0);
//
//      if (c_out_0) rl_0 = rl_0 + lpl_0 + 1;
//      if (c_not_0) rl_0 = rl_0 + lpl_0;
//
//      if (c_out_0) c_out_0 = (rl_0 <= lpl_0);
//      if (c_not_0) c_out_0 = (rl_0 <  lpl_0); c_not_0 = !c_out_0;
//
//      __fpl_1 = _Asm_xma  ( _XM_LU, __fvl_1, __ful_i, __fph_1);
//      __fph_1 = _Asm_xma  ( _XM_HU, __fvl_1, __ful_i, __fph_1);
//      lpl_1   = _Asm_getf ( _FR_SIG, __fpl_1);
//
//      if (c_out_1) rl_1 = rl_1 + lpl_1 + 1;
//      if (c_not_1) rl_1 = rl_1 + lpl_1;
//
//      if (c_out_1) c_out_1 = (rl_1 <= lpl_1);
//      if (c_not_1) c_out_1 = (rl_1 <  lpl_1); c_not_1 = !c_out_1;
//
//      __fpl_2 = _Asm_xma  ( _XM_LU, __fvl_2, __ful_i, __fph_2);
//      __fph_2 = _Asm_xma  ( _XM_HU, __fvl_2, __ful_i, __fph_2);
//      lpl_2   = _Asm_getf ( _FR_SIG, __fpl_2);
//
//      if (c_out_2) rl_2 = rl_2 + lpl_2 + 1;
//      if (c_not_2) rl_2 = rl_2 + lpl_2;
//
//      if (c_out_2) c_out_2 = (rl_2 <= lpl_2);
//      if (c_not_2) c_out_2 = (rl_2 <  lpl_2); c_not_2 = !c_out_2;
//
//      rp[i] = rl_0;
//
//      rl_0 = rl_1; rl_1 = rl_2;
//
//    }
//
//  hpl_0 = _Asm_getf ( _FR_SIG, __fph_0);
//  hpl_1 = _Asm_getf ( _FR_SIG, __fph_1);
//  hpl_2 = _Asm_getf ( _FR_SIG, __fph_2);
//
//  if (c_out_0) rl_0 = rl_0 + hpl_0 + 1;
//  if (c_not_0) rl_0 = rl_0 + hpl_0;
//
//  if (c_out_0) c_out_0 = (rl_0 <= hpl_0);
//  if (c_not_0) c_out_0 = (rl_0 <  hpl_0);
//
//  rp[n + 0] = rl_0;
//
//  if (c_out_1) rl_1 = rl_1 + hpl_1 + 1;
//  if (c_not_1) rl_1 = rl_1 + hpl_1;
//
//  if (c_out_1) c_out_1 = (rl_1 <= hpl_1);
//  if (c_not_1) c_out_1 = (rl_1 <  hpl_1);
//
//  if (c_out_0) rl_1++;
//  if (c_out_0) c_out_0 = (rl_1 == 0)
//
//  rp[n + 1] = rl_1;
//
//  if (c_out_2) rl_2 = hpl_2 + 1;
//  if (c_not_2) rl_2 = hpl_2;
//
//  if (c_out_1) rl_2++;
//
//  if (c_out_0) rl_2++;
//
//  return rl_2;
//
//}
//
//#endif
//
//#if GMP_NAIL_BITS >= 1
//you lose
//#endif
        .section .text
        .file "mul_3.s"
        .section .text, "xa", "progbits"
        .align 64
// -- Begin __gmpn_mul_3
        .proc __gmpn_mul_3#
        .global __gmpn_mul_3#

// Arguments //

Arg_RP=r32
Arg_UP=r33
Arg_N =r34
Arg_VP=r35

// ABI //

ret_val = r8 

savePR  = r27
savePFS = r28
saveLC  = r29

// Static GR //

// copies of args

reg_n = r14
pRPst = r15
pUP   = r16

// locals

hpl_0=r18
hpl_1=r19
hpl_2=r20

// Rotating GR //

lpl_0_3 = r32
lpl_0_4 = r33

lpl_1_3 = r34
lpl_1_4 = r35

lpl_2_3 = r36
lpl_2_4 = r37

// special rotation rl_3 -> rl_2 -> rl_1 -> rl_0

rl_2_0  = r41

rl_2_1  = r42
rl_1_0  = r42

rl_2_2  = r43
rl_1_1  = r43
rl_0_0  = r43

rl_2_3  = r44
rl_1_2  = r44
rl_0_1  = r44

rl_2_4  = r45
rl_1_3  = r45
rl_0_2  = r45

rl_1_4  = r46
rl_0_3  = r46

rl_0_4  = r47

// Static FR //

fvl_0 = f6
fvl_1 = f7
fvl_2 = f8

// Rotating FR //

ful_i_0=f32
ful_i_1=f33
ful_i_2=f34

fpl_0_2=f35
fpl_0_3=f36

fpl_1_2=f37
fpl_1_3=f38

fpl_2_2=f39
fpl_2_3=f40

fph_0_0=f43
fph_0_1=f44
fph_0_2=f45
fph_0_3=f46
fph_0_4=f47

fph_1_0=f48
fph_1_1=f49
fph_1_2=f50
fph_1_3=f51
fph_1_4=f52

fph_2_0=f53
fph_2_1=f54
fph_2_2=f55
fph_2_3=f56
fph_2_4=f57

// Rotating PR //

S0 = p16
S1 = p17
S2 = p18
S3 = p19
S4 = p20

c_out_1_0 = p21
c_out_1_1 = p22
c_out_1_2 = p23
c_out_1_3 = p24
c_out_1_4 = p25

c_out_0_0 = p26
c_out_0_1 = p27
c_out_0_2 = p28
c_out_0_3 = p29
c_out_0_4 = p30

c_not_1_0 = p31
c_not_1_1 = p32
c_not_1_2 = p33
c_not_1_3 = p34
c_not_1_4 = p35

c_not_0_0 = p36
c_not_0_1 = p37
c_not_0_2 = p38
c_not_0_3 = p39
c_not_0_4 = p40

c_out_2_0 = p46
c_out_2_1 = p47
c_out_2_2 = p48
c_out_2_3 = p49
c_out_2_4 = p50

c_not_2_0 = p56
c_not_2_1 = p57
c_not_2_2 = p58
c_not_2_3 = p59
c_not_2_4 = p60

__gmpn_mul_3:
{   .mmi
        alloc       savePFS=ar.pfs,4,12,0,16    // ABI 4 in 12 local 16 rotating
        nop.m       0                           // 
        mov         savePR=pr                   // ABI save PR
} {   .mmi
        nop.m       0                           // 
        nop.m       0                           //
        add         reg_n=-1,Arg_N              // pre-decrement for ar.lc
;; }
{   .mfi
        ldf8        fvl_0=[Arg_VP],8            // fvl_0 = vp[0]
        mov         fph_0_0=f0                  // fph_0 = 0
        mov         saveLC=ar.lc                // ABI save LC
;; }
{   .mfi
        ldf8        fvl_1=[Arg_VP],8            // fvl_1 = vp[1]
        mov         fph_1_0=f0                  // fph_1 = 0
        mov         pr.rot=0x10000              // set p16, clear higher
;; }
{   .mmi
        mov         rl_0_0=r0                   // rl_0 = 0
        mov         pRPst=Arg_RP                // initialize to &RP[0]
	mov         ar.lc=reg_n                 // load loop count register
;; }
{   .mmi
        nop.m       0                           // 
        mov         pUP=Arg_UP                  // copy from args to static
        mov         ar.ec=5                     // want normal swp loop
} {   .mmi
        cmp.ne      c_out_0_0,c_not_0_0=r0,r0   // c_out_0 and c_not_0
        cmp.ne      c_out_1_0,c_not_1_0=r0,r0   // c_out_1 and c_not_1
        nop.i       0                           // 
;; }
{    .mmf
        mov         rl_1_0=r0                   // rl_1 = 0
        nop.m       0                           //
        mov         fph_2_0=f0                  // fph_2 = 0;
} {  .mmi
	ldf8        fvl_2=[Arg_VP],8            // fvl_2 = vp[2];
        cmp.ne      c_out_2_0,c_not_2_0=r0,r0   // c_out_2 and c_not_2
        nop.i       0                           //
;; }
.rag_loop: 
	.pred.rel "mutex", c_out_0_4,c_not_0_4
{.mfi
(S3)     getf.sig   lpl_0_3=fpl_0_3             // lpl_0 = fpl_0
(S2)     xma.lu fpl_0_2=fvl_0,ful_i_2,fph_0_2   //
(c_out_0_4)add         rl_0_4=rl_0_4,lpl_0_4,1  // if(c_out_0)rl_0=rl_0+lpl_0+1;
} {.mfi
(S0)     ldf8        ful_i_0=[pUP],8            // ful_i_0 = up[i];
(S2)     xma.hu fph_0_1=fvl_0,ful_i_2,fph_0_2   // result needed next iteration
(c_not_0_4)add         rl_0_4=rl_0_4,lpl_0_4    // if(c_not_0)rl_0=rl_0+lpl_0;
;; }
	.pred.rel "mutex", c_out_1_4,c_not_1_4
{.mfi
(S3)     getf.sig   lpl_1_3=fpl_1_3             // lpl_1 = fpl_1
(S2)     xma.lu fpl_1_2=fvl_1,ful_i_2,fph_1_2   //
(c_out_1_4)add         rl_1_4=rl_1_4,lpl_1_4,1  // if(c_out_1)rl_1=rl_1+lpl_1+1;
} {.mfi
(S0)     mov         rl_2_0=r0                  // rl_2 = 0;
(S2)     xma.hu fph_1_1=fvl_1,ful_i_2,fph_1_2   // result needed next iteration
(c_not_1_4)add         rl_1_4=rl_1_4,lpl_1_4    // if(c_not_1)rl_1=rl_1+lpl_1;
;; }
	.pred.rel "mutex", c_out_0_4,c_not_0_4
	.pred.rel "mutex", c_out_1_4,c_not_1_4
{.mmi
(S4)     st8         [pRPst]=rl_0_4,8           // rp[i] = rl_0;
(c_out_0_4)cmp.leu c_out_0_3,c_not_0_3=rl_0_4,lpl_0_4  // (rl_0 <= lpl_0 )
(c_not_0_4)cmp.ltu c_out_0_3,c_not_0_3=rl_0_4,lpl_0_4  // (rl_0 <  lpl_0 )
} {.mmb
(c_out_1_4)cmp.leu c_out_1_3,c_not_1_3=rl_1_4,lpl_1_4  // (rl_1 <= lpl_1 )
(c_not_1_4)cmp.ltu c_out_1_3,c_not_1_3=rl_1_4,lpl_1_4  // (rl_1 <  lpl_1 )
         nop.b     0                            //
;; }
///////////////////////////////////////////////////////////
	.pred.rel "mutex", c_out_2_4,c_not_2_4
{.mfi
(S3)     getf.sig   lpl_2_3=fpl_2_3             // lpl_2 = fpl_2
(S2)     xma.lu fpl_2_2=fvl_2,ful_i_2,fph_2_2   //
(c_out_2_4)add         rl_2_4=rl_2_4,lpl_2_4,1  // if(c_out_2)rl_2=rl_2+lpl_2+1;
} {.mfi
         nop.m       0                          // 
(S2)     xma.hu fph_2_1=fvl_2,ful_i_2,fph_2_2   // result needed next iteration
(c_not_2_4)add         rl_2_4=rl_2_4,lpl_2_4    // if(c_not_2)rl_2=rl_2+lpl_2;
;; }
	.pred.rel "mutex", c_out_2_4,c_not_2_4
{.mmb
(c_out_2_4)cmp.leu c_out_2_3,c_not_2_3=rl_2_4,lpl_2_4  // (rl_2 <= lpl_2 )
(c_not_2_4)cmp.ltu c_out_2_3,c_not_2_3=rl_2_4,lpl_2_4  // (rl_2 <  lpl_2 )
         br.ctop.dptk .rag_loop                 //
;; }
///////////////////////////////////////////////////////////
{.mmi
         getf.sig   hpl_0=fph_0_4              // hpl_0 = fph_0
	 nop.m 0
	 nop.i 0
;; }
{.mmi
         getf.sig   hpl_1=fph_1_4              // hpl_1 = fph_1
	 nop.m 0
	 nop.i 0
;; }
{.mmi
         getf.sig   hpl_2=fph_2_4              // hpl_2 = fph_2
	 nop.m 0
	 nop.i 0
;; }
//////////////////
	.pred.rel "mutex", c_out_0_4,c_not_0_4
{.mmi
(c_out_0_4)add         rl_0_4=rl_0_4,hpl_0,1  // if(c_out_0)rl_0=rl_0+hpl_0+1;
(c_not_0_4)add         rl_0_4=rl_0_4,hpl_0    // if(c_not_0)rl_0=rl_0+hpl_0;
	   nop.i 0
;; }
	.pred.rel "mutex", c_out_0_4,c_not_0_4
{.mmi
        st8         [pRPst]=rl_0_4,8          // rp[n + 0] = rl_0;
(c_out_0_4)cmp.leu c_out_0_0,p0=rl_0_4,hpl_0  // (rl_0 <= hpl_0 )
(c_not_0_4)cmp.ltu c_out_0_0,p0=rl_0_4,hpl_0  // (rl_0 <  hpl_0 )
;; }
//////////////////
	.pred.rel "mutex", c_out_1_4,c_not_1_4
{.mmi
(c_out_1_4)add         rl_1_4=rl_1_4,hpl_1,1  // if(c_out_1)rl_1=rl_1+hpl_1+1;
(c_not_1_4)add         rl_1_4=rl_1_4,hpl_1    // if(c_not_1)rl_1=rl_1+hpl_1;
	   nop.i 0
;; }
	.pred.rel "mutex", c_out_1_4,c_not_1_4
{.mmi
           nop.m 0
(c_out_1_4)cmp.leu c_out_1_0,p0=rl_1_4,hpl_1  // (rl_1 <= hpl_1 )
(c_not_1_4)cmp.ltu c_out_1_0,p0=rl_1_4,hpl_1  // (rl_1 <  hpl_1 )
;; }
{.mmi
(c_out_0_0) add     rl_1_4=1,rl_1_4
           nop.m 0
           nop.i 0
;; }
{.mmi
        st8         [pRPst]=rl_1_4,8          // rp[n + 1] = rl_1;
(c_out_0_0) cmp.eq.unc c_out_0_1,p0=r0,rl_1_4 // (rl_1 == 0)
           nop.i 0
;;}
/////////////////
	.pred.rel "mutex", c_out_2_4,c_not_2_4
{.mmi
(c_out_2_4)add         rl_2_4=r0,hpl_2,1      // if(c_out_2)rl_2=hpl_2+1;
(c_not_2_4)add         rl_2_4=r0,hpl_2        // if(c_not_2)rl_2=hpl_2;
	nop.i 0
;; }
{.mii
(c_out_1_0) add rl_2_4=1,rl_2_4               // if(c_out_1)rl_1++
	mov         ar.lc = saveLC
        nop.i 0
;; }
{.mmi
(c_out_0_1) add rl_2_4=1,rl_2_4               // if(c_out_0)rl_2++
	nop.m 0
        nop.i 0
;; }
{ .mib
         mov        ret_val=rl_2_4            // return rl_2;
         mov        pr=savePR,0x1003e         // ABI
         br.ret.sptk.many b0                  // all done
;; }
// -- End __gmpn_mul_3
        .endp __gmpn_mul_3#
