        .file "rag_popcount.s"
//
//  INTEL CONFIDENTIAL
//
//  Intel intends to release this code under the LGPL license
//  as described below, but this code is still under development and testing.
//
//  Please report any problems with this function to the author at the email
//  address below or (503) 264-6622.
//
//  The easiest way to use this file is to save it as rag_add_n.s,
//  then assemble via ias rag_add_n.s
//  and finally link with the rag_add_n.o object file
//  before the -lgmp switch on the link command line.
//  Note: you may have to run the saved source though dos2unix.
//
//  Copyright 2005 Intel, Corp
//  This version (21-JUN-2005) was translated by Roger A Golliver,
//  roger.a.golliver@intel.com, for the Itanium(tm)-2 microarchitecture.
//
// IA-64 mpn_popcount -- mpn bit population count.
//
// Copyright 1994, 1996, 2000, 2001 Free Software Foundation, Inc.
//
// This file is part of the GNU MP Library.
//
// The GNU MP Library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at your
// option) any later version.
//
// The GNU MP Library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
// License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA. */
//
// #include "gmp.h"
// #include "gmp-impl.h"
//
// unsigned long
// mpn_popcount (mp_srcptr p, mp_size_t size)
// {
//   unsigned long  result = 0;
//   unsigned long  n;
//
//   ASSERT (size >= 1);
//
//   if (size & 1) {
//     popc_limb (n, *p++);
//     result += n;
//     size--;
//   }
//
//   if(!size)return result;
//
//   do {
//     popc_limb (n, *p++);
//     result += n;
//     popc_limb (n, *p++);
//     result += n;
//   } while ((size -= 2) != 0);
//
//   return result;
// }
    .section .text
    .section .text, "xa", "progbits"
    .align 64
    .proc   __gmpn_popcount#
    .global __gmpn_popcount#

// INPUT PARAMETERS

inPtr  = r32
inSize = r33

// SCRATCH GR's

pone = r3
ptwo = r2

retval = r8
size   = r9
sav_pr = r10
sav_ps = r11

// ROTATING GR's

o0 = r32
o1 = r33
o2 = r34
o3 = r35

e0 = r36
e1 = r37
e2 = r38
e3 = r39

// SCRATCH PR's 

Tone = p6   // size == 1
Fone = p7   // size != 1

Todd = p8   // size is odd

// ROTATING PR's

WT   = p16  // While True
W0   = p17  // While stage 0
W1   = p18  // While stage 1
W2   = p19  // While stage 2
W3   = p20  // While stage 3

__gmpn_popcount:
{   .mmi
        alloc       sav_ps=ar.pfs,2,6,0,8      // M2
        mov         retval=r0                  // M0
        tbit.nz.unc Todd,p0=inSize,0           // I0
} { .mmi
        mov         pone=inPtr                 // M1
        mov         size=inSize                // M3
        cmp.eq.unc  Tone,Fone=1,inSize     ;;  // I1
}

{   .mmi
 (Todd) ld8         retval=[pone],8            // M0
        nop.m       0                          // M1
 (Fone) mov         sav_pr=pr              ;;  // I0
} { .mmi
        add         ptwo=8,pone                // M0
        nop.m       0                          // M1
 (Fone) mov         pr.rot=0x20000         ;;  // I0
}

{   .mii
    nop.m    0
 (Todd) popcnt      retval=retval          ;;  // I0
 (Fone) mov         ar.ec=4                    // I0
} { .mmb
 (Todd) add         size=-1,size               // M0
        nop.m       0                          // M1
 (Tone) br.ret.dpnt.many    b0             ;;  // B0
}

.while_loop:
{   .mmi
 (W0)   ld8         o0=[pone],16               // M0
 (W3)   add         retval=retval,o3           // M1
 (W1)   popcnt      o1=o1                      // I0
} { .mmb
 (W0)   add         size=-2,size               // M2
        nop.m       0                          // M3
        nop.b       0                      ;;
}

{   .mmi
 (W0)   ld8         e0=[ptwo],16               // M0
 (W3)   add         retval=retval,e3           // M1
 (W1)   popcnt      e1=e1                      // I0
} { .mmb
 (W0)   cmp.ne      WT,p0=0,size               // M2
        nop.m       0                          // M3
 (WT)   br.wtop.dptk .while_loop           ;;  // B0
}

{   .mib
        nop.m       0                          // M0
        mov         pr=sav_pr,0x1003e          // I0
        br.ret.sptk.many b0                ;;  // B0
}
    .endp __gmpn_popcount#
